#!/bin/sh

### BEGIN INIT INFO
# Provides:          phoneui_daemon
# Required-Start:    $syslog property_service_daemon
# Required-Stop:     $syslog property_service_daemon
# Default-Start:     5
# Default-Stop:      0 1 2 3 4 6 7
# Short-Description: Launches Phone UI application
# Description:
### END INIT INFO

. /etc/init.d/init-functions

ENVFILE=/var/run/environment
. ${ENVFILE}

if [ -z "${HOOKSWITCH}" ]; then
    log_warning "required variable HOOKSWITCH not defined"
fi

if [ -z "${QWS_KEYBOARD}" ]; then
    log_warning "required variable QWS_KEYBOARD not defined"
fi

export HOOKSWITCH
export QWS_KEYBOARD

board=$(cut -d" " -f1,2 < /etc/model)
color_theme=""
if [ "${board}" == "Maxwell 2" ]; then
    color_theme="-rendergrayscale"
fi

NAME=maxwell-phoneui
DAEMON=/usr/sbin/DisplayGuiApp
WORKING_DIR=/var/run/
PIDFILE=${WORKING_DIR}/phoneui.pid
DAEMON_ARGS=" --hook-dev /dev/input/${HOOKSWITCH} -qws -nomouse ${color_theme}"

. /etc/init.d/maxwell-functions
