#!/bin/sh
### BEGIN INIT INFO
# Provides:          maxwell-teardown.sh
# Required-Start:
# Required-Stop:     maxwell-teardown
# Should-Stop:       $network $portmap
# Default-Start:
# Default-Stop:      6 7
# Short-Description: Keep some settings and files during reboot
### END INIT INFO

PATH=/sbin:/bin:/usr/sbin:/usr/bin

# Paths to the watchdog statistic/backup file
WD_STATS_FILE="/var/volatile/wd_stats.json"
BACKUP_FILE="/config/wd_stats.json"

# Store uptime before reboot the device
UPTIME=$(cat /proc/uptime | awk '{print int($1)}')
echo "Current uptime is: $UPTIME"
echo $UPTIME > /config/uptime

# Store watchdog stats file during reboot
if [ -f $WD_STATS_FILE ]; then
	cp $WD_STATS_FILE $BACKUP_FILE
fi
