#!/bin/sh

### BEGIN INIT INFO
# Provides:          property_service_daemon
# Required-Start:    $syslog mosquitto
# Required-Stop:     $syslog mosquitto
# Default-Start:     5
# Default-Stop:      0 1 2 3 4 6 7
# Short-Description: Launches Property Service daemon
# Description:
### END INIT INFO

. /etc/init.d/init-functions

NAME=maxwell-property-service
DAEMON=/usr/sbin/PropertyService
WORKING_DIR=/var/run/
PIDFILE=${WORKING_DIR}/propertyservice.pid
DAEMON_ARGS=""

. /etc/init.d/maxwell-functions

if [ "$1" == "start" ]; then
	timeout=60
	log_info "Waiting for property service to be in ready state..."
	/usr/sbin/propcli get State.PropertyService.Ready --wait-timeout ${timeout} 1>/dev/null
	status=$?
	if [ ${status} != "0" ]; then
		log_error "Property Service initialization timeout after ${timeout} seconds."
	else
		log_info "Property service is ready"
	fi
fi
