# Copyright 2017 Gigaset Communications GmbH

SCRIPT_NAME="maxwell-log-functions.sh"

function extract_tag()
{
    log_console="no"
    if [ "$1" == "-n" ]; then
        shift
        log_console="yes"
    fi
    log_string=$@

    array_size=${#BASH_SOURCE[@]}
    lineno_counter=0

    for elem in "${BASH_SOURCE[@]}"
    do
        if [ $(basename ${elem}) != ${SCRIPT_NAME}  ]; then
            break;
        fi

        lineno_counter=$((${lineno_counter}+1))
    done

    tag="[$(basename ${BASH_SOURCE[$((${array_size}-1))]})][$(basename ${BASH_SOURCE[$((${lineno_counter}))]}):${BASH_LINENO[$(($lineno_counter-1))]}]"

    if [[ ${BASH_SOURCE[2]} =~ [a-zA-Z\/]*rc[0-9S].* ]]; then
      tag=[$(echo ${BASH_SOURCE[2]} | awk -F/ '{print $(NF-1)}')]${tag}
    fi
}

log_to_console()
{
    if [ "${log_console}" = "yes" ] ; then
        echo $@
    fi
}

log_warning()
{
    extract_tag "$@"

    logger -p local2.warning -t "${tag}" "${log_string}"

    log_to_console "${log_string}"
}

log_error()
{
    extract_tag "$@"

    logger -p local2.err -t "${tag}" "${log_string}"

    log_to_console "${log_string}"
}

log_debug()
{
    extract_tag "$@"

    logger -p local2.debug -t "${tag}" "${log_string}"

    log_to_console "${log_string}"
}

log_info()
{
    extract_tag "$@"

    logger -p local2.info -t "${tag}" "${log_string}"

    log_to_console "${log_string}"
}