#!/bin/bash
# Copyright 2017 Gigaset Communications GmbH

source maxwell-log-functions.sh

PROPCLI="/usr/sbin/propcli"
TCPDUMP="/usr/sbin/tcpdump"
PACKETS_TILL_AUTOMATIC_STOP=30000
FILE_SIZE=3
FILE_COUNT=1
FILE_PATH="/var/volatile/pcap/pcap.log"
STATE_PROPERTY_NAME="State.Network.PCAP"
PIDFILE="/var/run/maxwel-pcap.pid"

OPTS="-c $PACKETS_TILL_AUTOMATIC_STOP -C $FILE_SIZE -W $FILE_COUNT -w $FILE_PATH"

case "$1" in
	start)
		log_info "Starting script"
		start-stop-daemon -S -b -x "$TCPDUMP" -m -p $PIDFILE -- $OPTS
		$($PROPCLI set $STATE_PROPERTY_NAME started)
		;;
	stop)
		log_info "Stopping script"
		start-stop-daemon -K -x "$TCPDUMP" -p $PIDFILE
		$($PROPCLI set $STATE_PROPERTY_NAME stopped)
		rm -f $PIDFILE
		;;
	delete)
		rm -f $FILE_PATH
		$($PROPCLI set $STATE_PROPERTY_NAME deleted)
		;;
	started|stopped|deleted)
		;;
	*)
		log_info "Usage is: $0 {start|stop|delete}" >&2
		exit 1
		;;
esac

exit 0
